﻿using System;
using System.IO;

namespace cutelogger
{
    public class Logger
    {
        public string LogPath { get; set; }
        private static string sessionLogFilepath;

        public Logger(string logPath)
        {
            LogPath = logPath;
            InitSession();
        }

        private void InitSession()
        {
            string fullPath = $"{LogPath}\\log_{DateTime.Now:yyyy_MM_dd}.txt";
            int count = 1;
            string fileNameOnly = Path.GetFileNameWithoutExtension(fullPath);
            string extension = Path.GetExtension(fullPath);
            string path = Path.GetDirectoryName(fullPath);
            sessionLogFilepath = fullPath;

            while (File.Exists(sessionLogFilepath))
            {
                string tempFileName = string.Format("{0}_{1}", fileNameOnly, count++);
                sessionLogFilepath = Path.Combine(path, tempFileName + extension);
            }
        }

        private void QL(string f, ConsoleColor c)
        {
            ConsoleColor temp = Console.ForegroundColor;
            Console.ForegroundColor = c;
            Console.Write(f);
            Console.ForegroundColor = temp;
            File.AppendAllText(sessionLogFilepath, f);
        }

        public void LogInfo(object sender, string content)
        {
            QL($"[{sender}] [INFO]: {content}\r\n", ConsoleColor.White);
        }

        public void LogWarning(object sender, string content)
        {
            QL($"[{sender}] [WARNING]: {content}\r\n", ConsoleColor.Yellow);
        }

        public void LogError(object sender, string content)
        {

            QL($"[{sender}] [ERROR]: {content}\r\n", ConsoleColor.Red);
        }

        public void LogFatal(object sender, string content)
        {
            QL($"[{sender}] [FATAL]: {content}\r\n", ConsoleColor.DarkRed);
        }
    }
}
